package body MSHTML.DispDOMKeyboardEvent_Object is

   function Get_bubbles
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_bubbles);
   end Get_bubbles;

   function Get_cancelable
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_cancelable);
   end Get_cancelable;

   function Get_currentTarget
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_currentTarget);
   end Get_currentTarget;

   function Get_defaultPrevented
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_defaultPrevented);
   end Get_defaultPrevented;

   function Get_eventPhase
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_eventPhase);
   end Get_eventPhase;

   function Get_target
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_target);
   end Get_target;

   function Get_timeStamp
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_timeStamp);
   end Get_timeStamp;

   function Get_type
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_type);
   end Get_type;

   procedure initEvent
     (This       : DispDOMKeyboardEvent_Type;
      eventType  : GNATCOM.Types.VARIANT;
      canBubble  : GNATCOM.Types.VARIANT;
      cancelable : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispDOMKeyboardEvent_initEvent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => cancelable,
          2 => canBubble,
          3 => eventType),
         Free);
   end initEvent;

   procedure preventDefault
     (This : DispDOMKeyboardEvent_Type)
   is
   begin
      Invoke (This, DispDOMKeyboardEvent_preventDefault);
   end preventDefault;

   procedure stopPropagation
     (This : DispDOMKeyboardEvent_Type)
   is
   begin
      Invoke (This, DispDOMKeyboardEvent_stopPropagation);
   end stopPropagation;

   procedure stopImmediatePropagation
     (This : DispDOMKeyboardEvent_Type)
   is
   begin
      Invoke (This, DispDOMKeyboardEvent_stopImmediatePropagation);
   end stopImmediatePropagation;

   function Get_isTrusted
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_isTrusted);
   end Get_isTrusted;

   procedure Put_cancelBubble
     (This : DispDOMKeyboardEvent_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         DispDOMKeyboardEvent_Put_cancelBubble,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_cancelBubble;

   function Get_cancelBubble
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_cancelBubble);
   end Get_cancelBubble;

   function Get_srcElement
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_srcElement);
   end Get_srcElement;

   function Get_view
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_view);
   end Get_view;

   function Get_detail
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_detail);
   end Get_detail;

   procedure initUIEvent
     (This       : DispDOMKeyboardEvent_Type;
      eventType  : GNATCOM.Types.VARIANT;
      canBubble  : GNATCOM.Types.VARIANT;
      cancelable : GNATCOM.Types.VARIANT;
      view       : GNATCOM.Types.VARIANT;
      detail     : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispDOMKeyboardEvent_initUIEvent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => detail,
          2 => view,
          3 => cancelable,
          4 => canBubble,
          5 => eventType),
         Free);
   end initUIEvent;

   function Get_key
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_key);
   end Get_key;

   function Get_location
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_location);
   end Get_location;

   function Get_ctrlKey
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_ctrlKey);
   end Get_ctrlKey;

   function Get_shiftKey
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_shiftKey);
   end Get_shiftKey;

   function Get_altKey
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_altKey);
   end Get_altKey;

   function Get_metaKey
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_metaKey);
   end Get_metaKey;

   function Get_repeat
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_repeat);
   end Get_repeat;

   function getModifierState
     (This   : DispDOMKeyboardEvent_Type;
      keyArg : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         DispDOMKeyboardEvent_getModifierState,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => keyArg),
         Free);
   end getModifierState;

   procedure initKeyboardEvent
     (This             : DispDOMKeyboardEvent_Type;
      eventType        : GNATCOM.Types.VARIANT;
      canBubble        : GNATCOM.Types.VARIANT;
      cancelable       : GNATCOM.Types.VARIANT;
      viewArg          : GNATCOM.Types.VARIANT;
      keyArg           : GNATCOM.Types.VARIANT;
      locationArg      : GNATCOM.Types.VARIANT;
      modifiersListArg : GNATCOM.Types.VARIANT;
      repeat           : GNATCOM.Types.VARIANT;
      locale           : GNATCOM.Types.VARIANT;
      Free             : Boolean := True)
   is
   begin
      Invoke
        (This,
         DispDOMKeyboardEvent_initKeyboardEvent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => locale,
          2 => repeat,
          3 => modifiersListArg,
          4 => locationArg,
          5 => keyArg,
          6 => viewArg,
          7 => cancelable,
          8 => canBubble,
          9 => eventType),
         Free);
   end initKeyboardEvent;

   function Get_keyCode
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_keyCode);
   end Get_keyCode;

   function Get_charCode
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_charCode);
   end Get_charCode;

   function Get_which
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_which);
   end Get_which;

   function Get_ie9_char
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_ie9_char);
   end Get_ie9_char;

   function Get_locale
     (This : DispDOMKeyboardEvent_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, DispDOMKeyboardEvent_Get_locale);
   end Get_locale;

end MSHTML.DispDOMKeyboardEvent_Object;

